<!DOCTYPE HTML>
<html lang="en">
<head>
<!-- Generated by javadoc (21) -->
<title>Source code</title>
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta name="description" content="source: package: org.apache.commons.cli, class: GnuParser">
<meta name="generator" content="javadoc/SourceToHTMLConverter">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
</head>
<body class="source-page">
<main role="main">
<div class="source-container">
<pre><span class="source-line-no">001</span><span id="line-1">/*</span>
<span class="source-line-no">002</span><span id="line-2">  Licensed to the Apache Software Foundation (ASF) under one or more</span>
<span class="source-line-no">003</span><span id="line-3">  contributor license agreements.  See the NOTICE file distributed with</span>
<span class="source-line-no">004</span><span id="line-4">  this work for additional information regarding copyright ownership.</span>
<span class="source-line-no">005</span><span id="line-5">  The ASF licenses this file to You under the Apache License, Version 2.0</span>
<span class="source-line-no">006</span><span id="line-6">  (the "License"); you may not use this file except in compliance with</span>
<span class="source-line-no">007</span><span id="line-7">  the License.  You may obtain a copy of the License at</span>
<span class="source-line-no">008</span><span id="line-8"></span>
<span class="source-line-no">009</span><span id="line-9">      http://www.apache.org/licenses/LICENSE-2.0</span>
<span class="source-line-no">010</span><span id="line-10"></span>
<span class="source-line-no">011</span><span id="line-11">  Unless required by applicable law or agreed to in writing, software</span>
<span class="source-line-no">012</span><span id="line-12">  distributed under the License is distributed on an "AS IS" BASIS,</span>
<span class="source-line-no">013</span><span id="line-13">  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</span>
<span class="source-line-no">014</span><span id="line-14">  See the License for the specific language governing permissions and</span>
<span class="source-line-no">015</span><span id="line-15">  limitations under the License.</span>
<span class="source-line-no">016</span><span id="line-16"> */</span>
<span class="source-line-no">017</span><span id="line-17"></span>
<span class="source-line-no">018</span><span id="line-18">package org.apache.commons.cli;</span>
<span class="source-line-no">019</span><span id="line-19"></span>
<span class="source-line-no">020</span><span id="line-20">import java.util.ArrayList;</span>
<span class="source-line-no">021</span><span id="line-21">import java.util.List;</span>
<span class="source-line-no">022</span><span id="line-22"></span>
<span class="source-line-no">023</span><span id="line-23">/**</span>
<span class="source-line-no">024</span><span id="line-24"> * The class GnuParser provides an implementation of the {@link Parser#flatten(Options, String[], boolean) flatten}</span>
<span class="source-line-no">025</span><span id="line-25"> * method.</span>
<span class="source-line-no">026</span><span id="line-26"> *</span>
<span class="source-line-no">027</span><span id="line-27"> * @deprecated since 1.3, use the {@link DefaultParser} instead</span>
<span class="source-line-no">028</span><span id="line-28"> */</span>
<span class="source-line-no">029</span><span id="line-29">@Deprecated</span>
<span class="source-line-no">030</span><span id="line-30">public class GnuParser extends Parser {</span>
<span class="source-line-no">031</span><span id="line-31">    /**</span>
<span class="source-line-no">032</span><span id="line-32">     * This flatten method does so using the following rules:</span>
<span class="source-line-no">033</span><span id="line-33">     * &lt;ol&gt;</span>
<span class="source-line-no">034</span><span id="line-34">     * &lt;li&gt;If an {@link Option} exists for the first character of the {@code arguments} entry &lt;b&gt;AND&lt;/b&gt; an</span>
<span class="source-line-no">035</span><span id="line-35">     * {@link Option} does not exist for the whole {@code argument} then add the first character as an option to the</span>
<span class="source-line-no">036</span><span id="line-36">     * processed tokens list e.g. "-D" and add the rest of the entry to the also.&lt;/li&gt;</span>
<span class="source-line-no">037</span><span id="line-37">     * &lt;li&gt;Otherwise just add the token to the processed tokens list.&lt;/li&gt;</span>
<span class="source-line-no">038</span><span id="line-38">     * &lt;/ol&gt;</span>
<span class="source-line-no">039</span><span id="line-39">     *</span>
<span class="source-line-no">040</span><span id="line-40">     * @param options The Options to parse the arguments by.</span>
<span class="source-line-no">041</span><span id="line-41">     * @param arguments The arguments that have to be flattened.</span>
<span class="source-line-no">042</span><span id="line-42">     * @param stopAtNonOption specifies whether to stop flattening when a non option has been encountered</span>
<span class="source-line-no">043</span><span id="line-43">     * @return a String array of the flattened arguments</span>
<span class="source-line-no">044</span><span id="line-44">     */</span>
<span class="source-line-no">045</span><span id="line-45">    @Override</span>
<span class="source-line-no">046</span><span id="line-46">    protected String[] flatten(final Options options, final String[] arguments, final boolean stopAtNonOption) {</span>
<span class="source-line-no">047</span><span id="line-47">        final List&lt;String&gt; tokens = new ArrayList&lt;&gt;();</span>
<span class="source-line-no">048</span><span id="line-48"></span>
<span class="source-line-no">049</span><span id="line-49">        boolean eatTheRest = false;</span>
<span class="source-line-no">050</span><span id="line-50"></span>
<span class="source-line-no">051</span><span id="line-51">        for (int i = 0; i &lt; arguments.length; i++) {</span>
<span class="source-line-no">052</span><span id="line-52">            final String arg = arguments[i];</span>
<span class="source-line-no">053</span><span id="line-53"></span>
<span class="source-line-no">054</span><span id="line-54">            if ("--".equals(arg)) {</span>
<span class="source-line-no">055</span><span id="line-55">                eatTheRest = true;</span>
<span class="source-line-no">056</span><span id="line-56">                tokens.add("--");</span>
<span class="source-line-no">057</span><span id="line-57">            } else if ("-".equals(arg)) {</span>
<span class="source-line-no">058</span><span id="line-58">                tokens.add("-");</span>
<span class="source-line-no">059</span><span id="line-59">            } else if (arg.startsWith("-")) {</span>
<span class="source-line-no">060</span><span id="line-60">                final String opt = Util.stripLeadingHyphens(arg);</span>
<span class="source-line-no">061</span><span id="line-61"></span>
<span class="source-line-no">062</span><span id="line-62">                if (options.hasOption(opt)) {</span>
<span class="source-line-no">063</span><span id="line-63">                    tokens.add(arg);</span>
<span class="source-line-no">064</span><span id="line-64">                } else if (opt.indexOf('=') != -1 &amp;&amp; options.hasOption(opt.substring(0, opt.indexOf('=')))) {</span>
<span class="source-line-no">065</span><span id="line-65">                    // the format is --foo=value or -foo=value</span>
<span class="source-line-no">066</span><span id="line-66">                    tokens.add(arg.substring(0, arg.indexOf('='))); // --foo</span>
<span class="source-line-no">067</span><span id="line-67">                    tokens.add(arg.substring(arg.indexOf('=') + 1)); // value</span>
<span class="source-line-no">068</span><span id="line-68">                } else if (options.hasOption(arg.substring(0, 2))) {</span>
<span class="source-line-no">069</span><span id="line-69">                    // the format is a special properties option (-Dproperty=value)</span>
<span class="source-line-no">070</span><span id="line-70">                    tokens.add(arg.substring(0, 2)); // -D</span>
<span class="source-line-no">071</span><span id="line-71">                    tokens.add(arg.substring(2)); // property=value</span>
<span class="source-line-no">072</span><span id="line-72">                } else {</span>
<span class="source-line-no">073</span><span id="line-73">                    eatTheRest = stopAtNonOption;</span>
<span class="source-line-no">074</span><span id="line-74">                    tokens.add(arg);</span>
<span class="source-line-no">075</span><span id="line-75">                }</span>
<span class="source-line-no">076</span><span id="line-76">            } else {</span>
<span class="source-line-no">077</span><span id="line-77">                tokens.add(arg);</span>
<span class="source-line-no">078</span><span id="line-78">            }</span>
<span class="source-line-no">079</span><span id="line-79"></span>
<span class="source-line-no">080</span><span id="line-80">            if (eatTheRest) {</span>
<span class="source-line-no">081</span><span id="line-81">                for (i++; i &lt; arguments.length; i++) { // NOPMD</span>
<span class="source-line-no">082</span><span id="line-82">                    tokens.add(arguments[i]);</span>
<span class="source-line-no">083</span><span id="line-83">                }</span>
<span class="source-line-no">084</span><span id="line-84">            }</span>
<span class="source-line-no">085</span><span id="line-85">        }</span>
<span class="source-line-no">086</span><span id="line-86"></span>
<span class="source-line-no">087</span><span id="line-87">        return tokens.toArray(Util.EMPTY_STRING_ARRAY);</span>
<span class="source-line-no">088</span><span id="line-88">    }</span>
<span class="source-line-no">089</span><span id="line-89">}</span>




























































</pre>
</div>
</main>
</body>
</html>
